IF Use.CloseFile = %True THEN
  DoTwo
  ? #2,"CloseFile Proc Near"
  ? #2,"Mov  AH,3Eh"
  ? #2,"Int  21h"
  ? #2,"Call TrapError"
  ? #2,"Ret"
  ? #2,"CloseFile Endp"
  DoTwo
END IF


IF Use.FlushFile = %True THEN
  DoTwo
  ? #2,"FlushFile Proc Near"
  ? #2,"Mov  AH,45h
  ? #2,"Int  21h
  ? #2,"Jb   FlushQuit
  ? #2,"Mov  BX,AX
  ? #2,"Mov  AH,3Eh
  ? #2,"Int  21h
  ? #2,"FlushQuit:
  ? #2,"Ret
  ? #2,"FlushFile Endp"
  DoTwo
END IF


IF Use.ReadFile = %True THEN
  DoTwo
  ? #2,"ReadFile Proc Near
  ? #2,"Push BX"          ' save the pointer to our handle variable
  ? #2,"Xor  AX,AX
  ? #2,"Mov  Eof,AX"      ' reset the EndOfFile global variable
  ? #2,"Mov  AH,3DH"      ' DOS open file for reading function
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Pop  BX"          ' recall our pointer to the handle
  ? #2,"Mov  [BX],AX"     ' and transfer the DOS handle to it indirectly
  ? #2,"Ret
  ? #2,"ReadFile Endp
  DoTwo
END IF



IF Use.AppendFile = %True THEN
  DoTwo
  ? #2,"AppendFile Proc Near
  ? #2,"Mov  AL,1
  ? #2,"Mov  AH,3DH"         ' open file for writing
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Mov  BX,AX"          ' move file handle
  ? #2,"Xor  CX,CX"          ' CX:DX is the seek offset
  ? #2,"Xor  DX,DX
  ? #2,"Mov  AH,42h"         ' move read/write pointer function
  ? #2,"Mov  AL,2"           ' ancillary function of seek
  ? #2,"Int  21h"            ' move pointer to end of file
  ? #2,"Call TrapError
  ? #2,"Ret"
  ? #2,"AppendFile Endp
  DoTwo
END IF


IF Use.CreateFile = %True THEN
  DoTwo
  ? #2,"CreateFile Proc Near
  ? #2,"Push DX"       ' save the pointer to the filename
  ? #2,"Push AX"       ' save the pointer to the handle
  ? #2,"Xor  CX,CX"    ' normal read/write attribute
  ? #2,"Mov  Eof,CX"   ' reset the global EndOfFile variable
  ? #2,"Mov  AH,3Ch"   ' DOS create file function
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Pop  BX"       ' recall the handle pointer
  ? #2,"Mov  [BX],AX"  ' copy the DOS handle to our handle variable indirectly
  ? #2,"Mov  BX,AX"    ' transfer the DOS handle to BX
  ? #2,"Mov  AH,3Eh"   ' DOS close file function
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Pop  DX"       ' recall the filename pointer
  ? #2,"Mov  AL,1
  ? #2,"Mov  AH,3DH"   ' DOS open file for writing function
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Ret
  ? #2,"Createfile Endp
  DoTwo
END IF


IF Use.Exist = %True THEN
  DoTwo
  ? #2,"Exist Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  DX,[BP+4]
  ? #2,"Mov  AX,3D00h
  ? #2,"Int  21h
  ? #2,"Jb   Exist_1
  ? #2,"Mov  BX,AX
  ? #2,"Mov  AH,3Eh
  ? #2,"Int  21h
  ? #2,"Mov  AX,-1
  ? #2,"Jmp  Exist_2
  ? #2,"Exist_1:
  ? #2,"Xor  AX,AX
  ? #2,"Exist_2:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Exist Endp
  DoTwo
END IF


IF Use.Sound = %True Then
  DoTwo
  ? #2,"Sound Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Cmp  BX,18
  ? #2,"Ja   Sound_1
  ? #2,"Mov  BX,19
  ? #2,"Sound_1:
  ? #2,"Mov  DX,18
  ? #2,"Mov  AX,34DCh
  ? #2,"Div  BX
  ? #2,"Mov  BL,AL
  ? #2,"Mov  AL,0B6h
  ? #2,"Out  43h,AL
  ? #2,"Mov  AL,BL
  ? #2,"Out  42h,AL
  ? #2,"Mov  AL,AH
  ? #2,"Out  42h,AL
  ? #2,"In   AL,61h
  ? #2,"Or   AL,3
  ? #2,"Out  61h,AL
  ? #2,"Mov  BX,1
  ? #2,"Mov  AL,[BP+6]
  ? #2,"Call Delay
  ? #2,"Sub  AL,AL
  ? #2,"Out  61h,AL
  ? #2,"Pop  BP
  ? #2,"Ret  4
  ? #2,"Sound Endp
  DoTwo
END IF


IF Use.Pset = %True THEN
  DoTwo
  ? #2,"Pset Proc Near
  ? #2,"Mov  AH,0CH
  ? #2,"Xor  BH,BH
  ? #2,"Int  10h
  ? #2,"Ret"
  ? #2,"Pset Endp
  DoTwo
END IF



IF Use.Point = %True THEN
  DoTwo
  ? #2,"Point Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AH,0Dh
  ? #2,"Xor  BX,BX"
  ? #2,"Mov  CX,[BP+4]
  ? #2,"Mov  DX,[BP+6]
  ? #2,"Int  10h
  ? #2,"Xor  AH,AH
  ? #2,"Pop  BP
  ? #2,"Ret  4
  ? #2,"Point  Endp
  DoTwo
END IF



IF Use.Line = %True THEN
  DoTwo
  ? #2,"Line Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,40
  ? #2,"Line_1:
  ? #2,"Mov  [BP-26],AX
  ? #2,"Mov  [BP-28],BX
  ? #2,"Mov  [BP-30],CX
  ? #2,"Mov  $Ycur,CX
  ? #2,"Mov  [BP-32],DX
  ? #2,"Mov  $Xcur,CX
  ? #2,"Mov  [BP-34],SI
  ? #2,"Mov  AX,[BP-26]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  AX,[BP-28]
  ? #2,"Mov  [BP-10],AX
  ? #2,"Mov  AX,[BP-30]
  ? #2,"Sub  AX,[BP-26]
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  AX,[BP-32]
  ? #2,"Sub  AX,[BP-28]
  ? #2,"Mov  [BP-4],AX
  ? #2,"Cmp  [BP-2],Word Ptr 0
  ? #2,"Jg   Line_2
  ? #2,"Not  Word Ptr [BP-2]
  ? #2,"Mov  [BP-14],Word Ptr -1
  ? #2,"Jmp  Line_3
  ? #2,"Line_2:
  ? #2,"Mov  [BP-14],Word Ptr 1
  ? #2,"Line_3:
  ? #2,"Cmp  [BP-4],Word Ptr 0
  ? #2,"Jg   Line_4
  ? #2,"Not  Word Ptr [BP-4]
  ? #2,"Mov  [BP-16],Word Ptr -1
  ? #2,"Jmp  Line_5
  ? #2,"Line_4:
  ? #2,"Mov  [BP-16],Word Ptr 1
  ? #2,"Line_5:
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   Line_6
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  BX,[BP-4]
  ? #2,"Mov  [BP-2],BX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  [BP-22],Word Ptr 0
  ? #2,"Mov  AX,[BP-16]
  ? #2,"Mov  [BP-24],AX
  ? #2,"Jmp  Line_7
  ? #2,"Line_6:
  ? #2,"Mov  AX,[BP-14]
  ? #2,"Mov  [BP-22],AX
  ? #2,"Mov  [BP-24],Word Ptr 0
  ? #2,"Line_7:
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Add  AX,[BP-4]
  ? #2,"Sub  AX,[BP-2]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Add  AX,[BP-4]
  ? #2,"Mov  [BP-20],AX
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Add  AX,[BP-4]
  ? #2,"Sub  AX,[BP-2]
  ? #2,"Sub  AX,[BP-2]
  ? #2,"Mov  [BP-18],AX
  ? #2,"Xor  AX,AX
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-12],AX
  ? #2,"Line_8:
  ? #2,"Inc  Word Ptr [BP-12]
  ? #2,"Mov  AX,[BP-12]
  ? #2,"Cmp  AX,[BP-2]
  ? #2,"Jg   Line_11
  ? #2,"Mov  AX,[BP-34]
  ? #2,"Mov  CX,[BP-10]
  ? #2,"Mov  DX,[BP-8]
  ? #2,"Mov  AH,0CH
  ? #2,"Xor  BH,BH
  ? #2,"Int  10h
  ? #2,"Cmp  [BP-6],Word Ptr 0
  ? #2,"Jg   Line_9
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-22]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  AX,[BP-10]
  ? #2,"Add  AX,[BP-24]
  ? #2,"Mov  [BP-10],AX
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Add  AX,[BP-20]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Jmp  Line_10
  ? #2,"Line_9:
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-14]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  AX,[BP-10]
  ? #2,"Add  AX,[BP-16]
  ? #2,"Mov  [BP-10],AX
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Add  AX,[BP-18]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Line_10:
  ? #2,"Jmp  Line_8
  ? #2,"Line_11:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Line Endp
  DoTwo
END IF

$Segment


IF Use.Circle = %True THEN
  DoTwo
  ? #2,"Circle Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Mov  BX,1000
  ? #2,"Imul BX
  ? #2,"Mov  CX,[BP+6]
  ? #2,"Idiv CX
  ? #2,"Push AX
  ? #2,"Xchg AX,CX
  ? #2,"Mov  CX,[BP+8]
  ? #2,"Imul BX
  ? #2,"Idiv CX
  ? #2,"Mov  [BP+6],AX
  ? #2,"Pop  AX
  ? #2,"Mov  [BP+8],AX
  ? #2,"Mov  AX,[BP+10]
  ? #2,"Mov  BX,1000
  ? #2,"Imul BX
  ? #2,"Xor  DI,DI
  ? #2,"Circ_5:
  ? #2,"Push AX
  ? #2,"Push DX
  ? #2,"Xor  BX,BX
  ? #2,"Add  AX,500
  ? #2,"Adc  DX,BX
  ? #2,"Mov  BX,1000
  ? #2,"Idiv BX
  ? #2,"Mov  BX,AX
  ? #2,"Add  AX,[BP+14]
  ? #2,"Mov  DX,[BP+12]
  ? #2,"Sub  DX,DI
  ? #2,"Mov  CX,AX
  ? #2,"Mov  AL,[BP+4]
  ? #2,"Mov  AH,12
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Sub  CX,BX
  ? #2,"Sub  CX,BX
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Add  DX,DI
  ? #2,"Add  DX,DI
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Add  CX,BX
  ? #2,"Add  CX,BX
  ? #2,"Int  10h
  ? #2,"Xchg CX,BX
  ? #2,"Inc  DI
  ? #2,"Mov  AX,DI
  ? #2,"Mov  BX,[BP+6]
  ? #2,"Imul BX
  ? #2,"Idiv CX
  ? #2,"Xor  DX,DX
  ? #2,"Mov  SI,AX
  ? #2,"Idiv BX
  ? #2,"Cmp  AX,1
  ? #2,"Pop  DX
  ? #2,"Pop  AX
  ? #2,"Jae  Circ_7
  ? #2,"Neg  SI
  ? #2,"Mov  BX,-1
  ? #2,"Add  AX,SI
  ? #2,"Adc  DX,BX
  ? #2,"Jmp  Circ_5
  ? #2,"Circ_7:
  ? #2,"Mov  AX,DI
  ? #2,"Mov  BX,1000
  ? #2,"Imul BX
  ? #2,"Mov  DI,CX
  ? #2,"Dec  DI
  ? #2,"Circ_8:
  ? #2,"Push AX
  ? #2,"Push DX
  ? #2,"Xor  BX,BX
  ? #2,"Add  AX,500
  ? #2,"Adc  DX,BX
  ? #2,"Mov  BX,1000
  ? #2,"Idiv BX
  ? #2,"Mov  BX,AX
  ? #2,"Add  AX,[BP+12]
  ? #2,"Mov  CX,[BP+14]
  ? #2,"Add  CX,DI
  ? #2,"Mov  DX,AX
  ? #2,"Mov  AL,[BP+4]
  ? #2,"Mov  AH,12
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Sub  CX,DI
  ? #2,"Sub  CX,DI
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Sub  DX,BX
  ? #2,"Sub  DX,BX
  ? #2,"Push AX
  ? #2,"Int  10h
  ? #2,"Pop  AX
  ? #2,"Add  CX,DI
  ? #2,"Add  CX,DI
  ? #2,"Int  10h
  ? #2,"Sub  DX,[BP+12]
  ? #2,"Neg  DX
  ? #2,"Xchg CX,DX
  ? #2,"Or   DI,DI
  ? #2,"Js   Circ_11
  ? #2,"Dec  DI
  ? #2,"Mov  AX,DI
  ? #2,"Mov  BX,[BP+8]
  ? #2,"Imul BX
  ? #2,"Idiv CX
  ? #2,"Mov  SI,AX
  ? #2,"Pop  DX
  ? #2,"Pop  AX
  ? #2,"Xor  BX,BX
  ? #2,"Or   SI,SI
  ? #2,"Jns  Circ_10
  ? #2,"Mov  BX,-1
  ? #2,"Circ_10:
  ? #2,"Add  AX,SI
  ? #2,"Adc  DX,BX
  ? #2,"Jmp  Circ_8
  ? #2,"Circ_11:
  ? #2,"Add  SP,4
  ? #2,"Pop  BP
  ? #2,"Ret  12
  ? #2,"Circle Endp
  DoTwo
END IF


IF Use.Screen = %True THEN
  DoTwo
  ? #2,"Screen Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AL,[BP+4]
  ? #2,"Xor  AH,AH
  ? #2,"Int  10h
  ? #2,"Mov  AX,1
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  $Ycur,AX
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Screen Endp
  DoTwo
END IF



IF Use.Bin2Dec = %True THEN
  DoTwo
  ? #2,"Bin2Dec Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,10
  ? #2,"Mov  Word Ptr[BP-10],1
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Mov  [BP-2],AX
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"B2D_1:
  ? #2,"Dec  Word Ptr[BP-4]
  ? #2,"Mov  AX,1
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   B2D_2
  ? #2,"Call ClrWork
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Mov  BX,1
  ? #2,"Call Mid$
  ? #2,"Call Concat_2
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call Assign
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call Val
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  BX,[BP-10]
  ? #2,"IMul BX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-6]
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  BX,[BP-10]
  ? #2,"Add  [BP-10],BX
  ? #2,"Jmp  B2D_1
  ? #2,"B2D_2:
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Bin2Dec Endp
  DoTwo
END IF


IF Use.Hex THEN
  DoTwo
  ? #2,"Hex$ Proc Near"            'Converts an int to a 4 digit Hex
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Push AX
  ? #2,"Xor  AL,AL
  ? #2,"Xchg AH,AL
  ? #2,"Mov  AH,al
  ? #2,"Call HexSub1
  ? #2,"Mov  $_1_,AL
  ? #2,"Call HexSub2
  ? #2,"Mov  $_1_+1,AL
  ? #2,"Pop  AX
  ? #2,"Xor  AH,AH
  ? #2,"Mov  AH,AL
  ? #2,"Call HexSub1
  ? #2,"Mov  $_1_+2,AL
  ? #2,"Call HexSub2
  ? #2,"Mov  $_1_+3,AL
  ? #2,"Mov  $_1_+4,0
  ? #2,"Jmp HexExit
  ? #2,"HexSub1:
  ? #2,"Shr  AL,4
  ? #2,"Add  AL,90h
  ? #2,"Daa
  ? #2,"Adc  AL,40h
  ? #2,"Daa
  ? #2,"Ret
  ? #2,"HexSub2:
  ? #2,"Mov  AL,AH
  ? #2,"And  AL,0Fh
  ? #2,"Add  AL,90h
  ? #2,"Daa
  ? #2,"Adc  AL,40h
  ? #2,"Daa
  ? #2,"Ret
  ? #2,"HexExit:
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Hex$ Endp
  DoTwo
END IF


IF Use.PutChar THEN
  DoTwo
  ? #2,"PutChar Proc Near"
  ? #2,"Mov  AH,AL"
  ? #2,"Mov  $Var0,AX"
  ? #2,"Mov  DX,Offset $Var0"
  ? #2,"Mov  CX,1"
  ? #2,"Mov  AH,40h"
  ? #2,"Int  21h"
  ? #2,"Call TrapError"
  ? #2,"Ret"
  ? #2,"PutChar Endp"
  DoTwo
END IF


IF Use.GetChar THEN
  DoTwo
  ? #2,"GetChar Proc Near"
  ? #2,"Mov  CX,1"
  ? #2,"Mov  DX,Offset $Var0"
  ? #2,"Mov  AH,3Fh"
  ? #2,"Int  21h"
  ? #2,"Mov  BX,AX"
  ? #2,"Mov  AX,[$Var0]"
  ? #2,"Xor  AH,AH"
  ? #2,"Cmp  BX,1"
  ? #2,"Je   GC1"
  ? #2,"Mov  AX,-1"
  ? #2,"GC1:"
  ? #2,"Ret"
  ? #2,"GetChar Endp"
  DoTwo
END IF


IF Use.ShowHideCursor THEN
  DoTwo
  ? #2,"ShowHideCursor Proc Near
  ? #2,"Cmp  AX,0
  ? #2,"Je   Sh1
  ? #2,"Mov  CL,13
  ? #2,"Mov  CH,12
  ? #2,"Mov  AH,01
  ? #2,"Int  10h
  ? #2,"Jmp  Sh2
  ? #2,"Sh1:
  ? #2,"Xor  CL,CL
  ? #2,"Mov  CH,1
  ? #2,"Mov  AH,1
  ? #2,"Int  10h
  ? #2,"Sh2:
  ? #2,"Ret
  ? #2,"ShowHideCursor Endp
  DoTwo
END IF


IF Use.ArraySort THEN
  DoTwo
  ? #2,"ArraySort Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,8
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  [BP-6],Word Ptr 0
  ? #2,"Sort_1:
  ? #2,"Add  [BP-6],Word Ptr 1
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   Sort_5
  ? #2,"Mov  [BP-8],Word Ptr 0
  ? #2,"Sort_2:
  ? #2,"Add  [BP-8],Word Ptr 1
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Cmp  AX,[BP-4]
  ? #2,"Jg   Sort_4
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-8]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayGet
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Push Offset $_1_
  ? #2,"Push [BP-2]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayGet
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Call StrCompare
  ? #2,"Jle  Sort_3
  ? #2,"Push Offset $_1_
  ? #2,"Push [BP-8]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-2]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Sort_3:
  ? #2,"Jmp  Sort_2
  ? #2,"Sort_4:
  ? #2,"Jmp  Sort_1
  ? #2,"Sort_5:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  4
  ? #2,"ArraySort Endp
  DoTwo
END IF


IF Use.ArrayInsert THEN
  DoTwo
  ? #2,"ArrayInsert Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,6
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Insert_1:
  ? #2,"Sub  [BP-2],Word Ptr 1
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Cmp  AX,[BP-2]
  ? #2,"Jg   Insert_2
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-2]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayGet
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-6]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Jmp  Insert_1
  ? #2,"Insert_2:
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP+6]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"ArrayInsert Endp
  DoTwo
END IF


IF Use.ArrayDelete THEN
  DoTwo
  ? #2,"ArrayDelete Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,6
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Delete_1:
  ? #2,"Add  [BP-2],Word Ptr 1
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP-6]
  ? #2,"Jg   Delete_2
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-4]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayGet
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-2]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Jmp  Delete_1
  ? #2,"Delete_2:
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP+8]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayPut
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"ArrayDelete Endp
  DoTwo
END IF


IF Use.Scan = %True THEN
  DoTwo
  ? #2,"Scan Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,2
  ? #2,"Mov  [BP-2],Word Ptr 0
  ? #2,"Mov  DI,Offset $_0_
  ? #2,"Mov  [DI],  Byte Ptr 0
  ? #2,"Mov  [BP-2],Word Ptr 0
  ? #2,"Scan_1:
  ? #2,"Add  [BP-2],Word Ptr 1
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP+8]
  ? #2,"Jg   Scan_3
  ? #2,"Push Offset $_0_
  ? #2,"Push [BP-2]
  ? #2,"Push [BP+4]
  ? #2,"Call ArrayGet
  ? #2,"Mov  SI,Offset $_0_
  ? #2,"Mov  DI,[BP+6]
  ? #2,"Call StrCompare
  ? #2,"Jne  Scan_2
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"Scan_2:
  ? #2,"Jmp Scan_1
  ? #2,"Scan_3:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"Scan Endp
  DoTwo
END IF


IF Use.ArrayPut THEN
  DoTwo
  ? #2,"ArrayPut Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  AH,[BX]
  ? #2,"Mov  AL,[BX+01]
  ? #2,"Mov  BX,[BP+6]
  ? #2,"Mul  BX
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  CH,[BX]
  ? #2,"Mov  CL,[BX+1]
  ? #2,"Sub  AX,CX
  ? #2,"Mov  DI,[BP+4]
  ? #2,"Add  DI,AX
  ? #2,"Inc  DI
  ? #2,"Inc  DI
  ? #2,"Push DI
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Pop  DI
  ? #2,"Mov  SI,[BP+8]
  ? #2,"Call MoveStr
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"ArrayPut Endp
  DoTwo
END IF


IF Use.ArrayGet = %True THEN
  DoTwo
  ? #2,"ArrayGet Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  DI,[BP+8]
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  AH,[BX]
  ? #2,"Mov  AL,[BX+01]
  ? #2,"Mov  BX,[BP+6]
  ? #2,"Mul  BX
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  CH,[BX]
  ? #2,"Mov  CL,[BX+1]
  ? #2,"Sub  AX,CX
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Add  SI,AX
  ? #2,"Inc  SI
  ? #2,"Inc  SI
  ? #2,"Mov  DI,[BP+8]
  ? #2,"Call MoveStr
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"ArrayGet Endp
  DoTwo
END IF


IF Use.GetScreen THEN
  DoTwo
  ? #2,"GetScreen Proc Near
  ? #2,"Push ES
  ? #2,"Push DS
  ? #2,"Push AX
  ? #2,"Pop  ES
  ? #2,"Call VideoCard
  ? #2,"Push AX
  ? #2,"Pop  DS
  ? #2,"Xor  SI,SI
  ? #2,"Xor  DI,DI
  ? #2,"Mov  CX,2000
  ? #2,"Cld
  ? #2,"Rep  Movs Word Ptr ES:[DI],Word Ptr DS:[SI]
  ? #2,"Pop  DS
  ? #2,"Pop  ES
  ? #2,"Ret
  ? #2,"GetScreen Endp
  DoTwo
END IF


IF Use.PutScreen THEN
  DoTwo
  ? #2,"PutScreen Proc Near
  ? #2,"Push DS
  ? #2,"Push ES
  ? #2,"Push AX
  ? #2,"Pop  DS
  ? #2,"Call VideoCard
  ? #2,"Mov  ES,AX
  ? #2,"Xor  DI,DI
  ? #2,"Xor  SI,SI
  ? #2,"Mov  CX,2000
  ? #2,"Cld
  ? #2,"Rep  Movs Word Ptr ES:[DI],Word Ptr DS:[SI]
  ? #2,"Pop  ES
  ? #2,"Pop  DS
  ? #2,"Ret
  ? #2,"PutScreen Endp
  DoTwo
END IF


IF Use.Ticks THEN
  DoTwo
  ? #2,"Ticks Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Push DefSeg
  ? #2,"Mov  DefSeg,64
  ? #2,"Mov  AX,108
  ? #2,"Call Peek
  ? #2,"Pop  BX
  ? #2,"Mov  DefSeg,BX
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Ticks Endp
  DoTwo
END IF


IF Use.Pow THEN
  DoTwo
  ? #2,"Pow  Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,4
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Pow_1:
  ? #2,"Inc  Word Ptr[BP-2]
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP+6]
  ? #2,"Jg   Pow_2
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Imul Word Ptr[BP+4]"
  ? #2,"Mov  [BP-4],AX
  ? #2,"Jmp  Pow_1
  ? #2,"Pow_2:
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  4
  ? #2,"Pow Endp
  DoTwo
END IF


IF Use.MoveMem THEN
  DoTwo
  ? #2,"Movemem Proc Near"
  ? #2,"Push BP"
  ? #2,"Mov  BP,SP"
  ? #2,"Cld"                                   ' Count upwards
  ? #2,"Push DS"                               ' Preserve our DATA Segment
  ? #2,"Push ES"                               ' and EXTRA Segment
  ? #2,"Push [BP+4]"                           ' get the SourceSeg
  ? #2,"Pop  DS"                               ' make it the DATA Segment
  ? #2,"Mov  SI,[BP+6]"                        ' make SI = SourceOffset
  ? #2,"Push [BP+8]"                           ' get the DestinationSeg
  ? #2,"Pop  ES"                               ' make it the EXTRA Segment
  ? #2,"Mov  DI,[BP+10]"                       ' make DI = DestinationOffset
  ? #2,"Mov  CX,[BP+12]"                       ' get the ByteCount
  ? #2,"Rep  Movs Byte Ptr ES:[DI],Byte Ptr DS:[SI]"' do the transfer
  ? #2,"Pop  ES"                               ' Restore our DATA Segment
  ? #2,"Pop  DS"                               ' and EXTRA Segment
  ? #2,"Pop  BP"
  ? #2,"Ret  10"
  ? #2,"MoveMem Endp"
  DoTwo
END IF


IF Use.Alloc THEN
  DoTwo
  ? #2,"Alloc Proc Near
  ? #2,"Mov  BX,AX
  ? #2,"Shr  BX,4
  ? #2,"Inc  BX
  ? #2,"Mov  DX,BX
  ? #2,"Shl  DX,4
  ? #2,"Mov  AH,48h
  ? #2,"Int  21h
  ? #2,"Jnc  AllocOk
  ? #2,"Xor  AX,AX
  ? #2,"AllocOk:
  ? #2,"Clc
  ? #2,"Ret
  ? #2,"Alloc Endp
  DoTwo
END IF


IF Use.Release THEN
  DoTwo
  ? #2,"Release Proc Near
  ? #2,"Push ES
  ? #2,"Push AX
  ? #2,"Pop  ES
  ? #2,"Mov  AH,49h
  ? #2,"Int  21h
  ? #2,"Pop  ES
  ? #2,"Ret
  ? #2,"Release Endp
  DoTwo
END IF


IF Use.Freemem THEN
  DoTwo
  ? #2,"Freemem Proc Near
  ? #2,"Mov  BX,0FFFFh
  ? #2,"Mov  AH,48h
  ? #2,"Int  21h
  ? #2,"Mov  AX,BX
  ? #2,"Shr  AX,4
  ? #2,"Ret
  ? #2,"Freemem Endp
  DoTwo
END IF


IF Use.Ustr THEN
  DoTwo
  ? #2,"UStr$ Proc Near"          ' Entry: AX=Word  ES:DI= string
  ? #2,"Xor  CX,CX"               ' Returns unsigned value 0 to 65535
  ? #2,"Mov  BX,10
  ? #2,"Ustr_1:
  ? #2,"Inc  CX
  ? #2,"Xor  DX,DX
  ? #2,"Div  BX
  ? #2,"Push DX
  ? #2,"Cmp  AX,0
  ? #2,"Jne  Ustr_1
  ? #2,"Ustr_2:
  ? #2,"Pop  AX
  ? #2,"Add  AL,'0'
  ? #2,"Mov  [DI],AL
  ? #2,"Inc  DI
  ? #2,"Loop Ustr_2
  ? #2,"Xor  AX,AX
  ? #2,"Mov  [DI],AL
  ? #2,"Ret
  ? #2,"Ustr$ Endp
  DoTwo
END IF


IF Use.Asc2 = %True THEN
  DoTwo
  ? #2,"Asc2 Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Add  SI,[BP+6]
  ? #2,"Dec  SI
  ? #2,"Mov  AL,[SI]
  ? #2,"Xor  AH,AH
  ? #2,"Pop  BP
  ? #2,"Ret  4
  ? #2,"Asc2 Endp
  DoTwo
END IF


IF Use.Midd = %True THEN
  DoTwo
  ? #2,"Midd Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Cmp  AX,[BP+6]
  ? #2,"Jge  Midd_1
  ? #2,"Call ClrWork
  ? #2,"Mov  DI,Offset $_1_
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Call Space$
  ? #2,"Call Concat_2
  ? #2,"Mov  DI,[BP+4]
  ? #2,"Call Assign
  ? #2,"Midd_1:
  ? #2,"Mov  SI,Offset [BP+4]
  ? #2,"Add  SI,[BP+6]
  ? #2,"Dec  SI
  ? #2,"Mov  BX,[BP+8]
  ? #2,"Midd_2:
  ? #2,"Mov  AX,[BX]
  ? #2,"Or   AL,AL
  ? #2,"Jz   Midd_3
  ? #2,"Mov  [SI],AL
  ? #2,"Or   AL,AL
  ? #2,"Jz   Midd_3
  ? #2,"Inc  BX
  ? #2,"Inc  SI
  ? #2,"Jmp  Midd_2
  ? #2,"Midd_3:
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"Midd Endp
  DoTwo
END IF



IF Use.CpuID = %True THEN
  DoTwo
  ? #2,"CpuID Proc Near
  ? #2,"Xor  AX,AX
  ? #2,"Push AX
  ? #2,"Popf
  ? #2,"Pushf
  ? #2,"Pop  AX
  ? #2,"And  AX,0F000h
  ? #2,"Cmp  AX,0F000h
  ? #2,"Jnz  CpuID_2
  ? #2,"Push CX
  ? #2,"Mov  AX,0FFFFh
  ? #2,"Mov  CL,21h
  ? #2,"Shl  AX,CL
  ? #2,"Pop  CX
  ? #2,"Jnz  CpuID_1
  ? #2,"Xor  AX,AX
  ? #2,"Jmp  CpuID_Exit
  ? #2,"CpuID_1:
  ? #2,"Mov  AX,1
  ? #2,"Jmp  CpuID_Exit
  ? #2,"CpuID_2:
  ? #2,"Mov  AX,7000h
  ? #2,"Push AX
  ? #2,"Popf
  ? #2,"Pushf
  ? #2,"Pop  AX
  ? #2,"And  AX,7000h
  ? #2,"Jnz  CpuID_3
  ? #2,"Mov  AX,2
  ? #2,"Jmp  CpuID_Exit
  ? #2,"CpuID_3:
  ? #2,"Push DX
  ? #2,"Mov  DX,0003
  ? #2,"DB 66H,50H,66H,53H
  ? #2,"DB 66H,51H,66H,8BH
  ? #2,"DB 0DCH,66H,83H,0E4H
  ? #2,"DB 8CH,66H,9CH,66H
  ? #2,"DB 58H,66H,8BH,0C8H
  ? #2,"DB 66H,35H,00h,00h
  ? #2,"DB 04H,00H,66H,50H
  ? #2,"DB 66H,9DH,66H,9CH
  ? #2,"DB 66H,58H,66H,25H
  ? #2,"DB 00H,00H,04H,00H
  ? #2,"DB 66H,81H,0E1H,00H,00H
  ? #2,"DB 04H,00H,66H,3BH,0C1H
  ? #2,"JZ CpuID_4
  ? #2,"Mov  DX,4
  ? #2,"CpuID_4:
  ? #2,"DB 66H,51H,66H,9DH
  ? #2,"DB 66H,8BH,0E3H
  ? #2,"DB 66H,59H,66H,5BH
  ? #2,"DB 66H,58H
  ? #2,"Mov  AX,DX
  ? #2,"Pop  DX
  ? #2,"CpuID_Exit:
  ? #2,"Ret
  ? #2,"CpuID  ENDP
  DoTwo
END IF


IF Use.Lprint = %True THEN
  DoTwo
  ? #2,"Lprint Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Mov  CX,AX
  ? #2,"Mov  BX,4
  ? #2,"Mov  DX,[BP+4]
  ? #2,"Mov  AH,40h
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Lprint Endp
  DoTwo
END IF


IF Use.LprintNL = %True THEN
  DoTwo
  ? #2,"LprintNL Proc Near
  ? #2,"Mov  BX,4
  ? #2,"Mov  CX,2
  ? #2,"Mov  DX,Offset $CrLf
  ? #2,"Mov  AH,40h
  ? #2,"Int  21h
  ? #2,"Call TrapError
  ? #2,"Ret
  ? #2,"LprintNL Endp
  DoTwo
END IF


IF Use.GetStr = %True THEN
  DoTwo
  ? #2,"Get$ Proc near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  DI,[BP+8]
  ? #2,"Mov  [DI],Byte Ptr 0
  ? #2,"Mov  CX,[BP+6]
  ? #2,"Mov  DX,[BP+8]
  ? #2,"Mov  Eof,Word Ptr 0
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  AH,3Fh
  ? #2,"Int  21h
  ? #2,"Mov  DI,[BP+8]
  ? #2,"Add  DI,AX
  ? #2,"Mov  [DI],Byte Ptr 0"            'terminate actual length of string
  ? #2,"Cmp  AX,[BP+6]
  ? #2,"Je   Get$_1
  ? #2,"Mov  BX,-1
  ? #2,"Mov  Eof,BX
  ? #2,"Get$_1:
  ? #2,"Pop  BP
  ? #2,"Call TrapError
  ? #2,"Ret  6
  ? #2,"Get$ Endp
  DoTwo
END IF



IF Use.PutStr = %True THEN
  DoTwo
  ? #2,"Put$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+6]
  ? #2,"Call Len"        'suggestion -- pass the len as a parameter ...
  ? #2,"Mov  CX,AX
  ? #2,"Mov  BX,[BP+4]
  ? #2,"Mov  DX,[BP+6]
  ? #2,"Mov  AH,40h
  ? #2,"Int  21h
  ? #2,"Pop  BP
  ? #2,"Call TrapError
  ? #2,"Ret  6
  ? #2,"Put$ Endp
  DoTwo
END IF



IF Use.Get THEN
  DoTwo
  ? #2,"Get  Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,10
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Sub  AX,[BP+4]
  ? #2,"Inc  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  AX,[BP+10]
  ? #2,"Inc  AX"           '<<<  added on 2/10/97 to fix a bug where y1=y2
  ? #2,"Sub  AX,[BP+6]
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  AX,1
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+12]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  [BX],AX
  ? #2,"Mov  AX,2
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+12]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Mov  [BX],AX
  ? #2,"Mov  Word Ptr[BP-6],3
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-4],AX
  ? #2,"Get_1:
  ? #2,"Inc  Word Ptr[BP-4]
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Cmp  AX,[BP+10]
  ? #2,"Jle  Get_2
  ? #2,"Jmp  Get_6
  ? #2,"Get_2:
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-2],AX
  ? #2,"Get_3:
  ? #2,"Inc  Word Ptr[BP-2]
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Cmp  AX,[BP+8]
  ? #2,"Jle  Get_4
  ? #2,"Jmp  Get_5
  ? #2,"Get_4:
  ? #2,"Push [BP-4]
  ? #2,"Push [BP-2]
  ? #2,"Call Point
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  AX,[BP-6]
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+12]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Mov  [BX],AX
  ? #2,"Inc  Word Ptr[BP-6]
  ? #2,"Jmp  Get_3
  ? #2,"Get_5:
  ? #2,"Jmp  Get_1
  ? #2,"Get_6:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  10
  ? #2,"Get  Endp
  DoTwo
END IF



IF Use.Put THEN
  DoTwo
  ? #2,"Put  Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,20
  ? #2,"Mov  AX,1
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+8]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BX]
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  AX,2
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+8]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BX]
  ? #2,"Mov  [BP-4],AX
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Add  AX,[BP-2]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-6],AX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Add  AX,[BP-4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-8],AX
  ? #2,"Mov  Word Ptr[BP-12],3
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-16],AX
  ? #2,"Put_1:
  ? #2,"Inc  Word Ptr[BP-16]
  ? #2,"Mov  AX,[BP-16]
  ? #2,"Cmp  AX,[BP-8]
  ? #2,"Jle  Put_2
  ? #2,"Jmp  Put_6
  ? #2,"Put_2:
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  [BP-14],AX
  ? #2,"Put_3:
  ? #2,"Inc  Word Ptr[BP-14]
  ? #2,"Mov  AX,[BP-14]
  ? #2,"Cmp  AX,[BP-6]
  ? #2,"Jle  Put_4
  ? #2,"Jmp  Put_5
  ? #2,"Put_4:
  ? #2,"Mov  AX,[BP-12]
  ? #2,"Shl  AX,1
  ? #2,"Dec  AX
  ? #2,"Mov  BX,Offset [BP+8]
  ? #2,"Add  BX,AX
  ? #2,"Mov  AX,[BX]
  ? #2,"Mov  [BP-10],AX
  ? #2,"Inc  Word Ptr[BP-12]
  ? #2,"Mov  CX,[BP-14]
  ? #2,"Mov  DX,[BP-16]
  ? #2,"Mov  AX,[BP-10]
  ? #2,"Call Pset
  ? #2,"Jmp  Put_3
  ? #2,"Put_5:
  ? #2,"Jmp  Put_1
  ? #2,"Put_6:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  6
  ? #2,"Put  Endp
  DoTwo
END IF



IF Use.Blank = %True THEN
  DoTwo
  ? #2,"Blank Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Dec  AX
  ? #2,"Mov  CL,AL
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Dec  AX
  ? #2,"Mov  CH,AL
  ? #2,"Mov  AX,[BP+8]
  ? #2,"Dec  AX
  ? #2,"Mov  DL,AL
  ? #2,"Mov  AX,[BP+10]
  ? #2,"Dec  AX
  ? #2,"Mov  DH,AL
  ? #2,"Mov  AH,6
  ? #2,"Mov  AL,0
  ? #2,"Mov  BX,$Attr
  ? #2,"Xchg BH,BL
  ? #2,"Int  10h
  ? #2,"Pop  BP
  ? #2,"Ret  8
  ? #2,"Blank Endp
  DoTwo
END IF



IF Use.Paint = %True THEN
  DoTwo
  ? #2,"Paint Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Sub  SP,16
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Mov  [BP-4],AX
  ? #2,"Paint_1:
  ? #2,"Call Paint_5
  ? #2,"Call Paint_9
  ? #2,"Call Paint_14
  ? #2,"Dec  Word Ptr[BP-4]
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-10]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Cmp  Word Ptr[BP-6],2
  ? #2,"Jne  Paint_2
  ? #2,"Jmp  Paint_1
  ? #2,"Paint_2:
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  [BP-2],AX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Mov  [BP-4],AX
  ? #2,"Paint_3:
  ? #2,"Call Paint_5
  ? #2,"Call Paint_9
  ? #2,"Call Paint_14
  ? #2,"Inc  Word Ptr[BP-4]
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-10]
  ? #2,"Mov  [BP-6],AX
  ? #2,"Cmp  Word Ptr[BP-6],2
  ? #2,"Jne  Paint_4
  ? #2,"Jmp  Paint_3
  ? #2,"Paint_4:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  8
  ? #2,"Paint_5:
  ? #2,"Cmp  Word Ptr[BP-2],0
  ? #2,"Je   Paint_8
  ? #2,"Push [BP-4]
  ? #2,"Push [BP-2]
  ? #2,"Call Point
  ? #2,"Mov  [BP-6],AX
  ? #2,"Cmp  AX,[BP+10]
  ? #2,"Jne  Paint_6
  ? #2,"Jmp  Paint_7
  ? #2,"Paint_6:
  ? #2,"Dec  Word Ptr[BP-2]
  ? #2,"Mov  Word Ptr[BP-8],0
  ? #2,"Jmp Paint_5
  ? #2,"Paint_7:
  ? #2,"Inc  Word Ptr[BP-2]
  ? #2,"Mov  Word Ptr[BP-8],1
  ? #2,"Paint_8:
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  [BP-12],AX
  ? #2,"Ret
  ? #2,"Paint_9:
  ? #2,"Cmp  [BP-2],1024
  ? #2,"Je   Paint_13
  ? #2,"Jmp  Paint_10
  ? #2,"Paint_10:
  ? #2,"Push [BP-4]
  ? #2,"Push [BP-2]
  ? #2,"Call Point
  ? #2,"Mov  [BP-6],AX
  ? #2,"Cmp  AX,[BP+10]
  ? #2,"Jne  Paint_11
  ? #2,"Jmp  Paint_12
  ? #2,"Paint_11:
  ? #2,"Inc  Word Ptr[BP-2]
  ? #2,"Mov  Word Ptr[BP-10],0
  ? #2,"Jmp Paint_9
  ? #2,"Paint_12:
  ? #2,"Dec  Word Ptr[BP-2]
  ? #2,"Mov  Word Ptr[BP-10],1
  ? #2,"Jmp Paint_13
  ? #2,"Paint_13:
  ? #2,"Mov  AX,[BP-2]
  ? #2,"Mov  [BP-14],AX
  ? #2,"Ret
  ? #2,"Paint_14:
  ? #2,"Mov  AX,[BP-8]
  ? #2,"Add  AX,[BP-10]
  ? #2,"Cmp  AX,2
  ? #2,"Je   Paint_15
  ? #2,"Jmp  Paint_16
  ? #2,"Paint_15:
  ? #2,"Mov  AX,[BP-4]
  ? #2,"Mov  BX,[BP-12]
  ? #2,"Mov  CX,[BP-4]
  ? #2,"Mov  DX,[BP-14]
  ? #2,"Mov  SI,[BP+8]
  ? #2,"Call Line
  ? #2,"Paint_16:
  ? #2,"Mov  AX,[BP-12]
  ? #2,"Add  AX,[BP-14]
  ? #2,"Shr  AX,1
  ? #2,"Mov  [BP-2],AX
  ? #2,"Ret
  ? #2,"Paint Endp
  DoTwo
END IF


IF Use.LineTo = %True THEN
  DoTwo
  ? #2,"Lineto Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AX,$Ycur
  ? #2,"Mov  BX,$Xcur
  ? #2,"Mov  CX,[BP+6]
  ? #2,"Mov  DX,[BP+4]
  ? #2,"Mov  SI,[BP+8]
  ? #2,"Call Line
  ? #2,"Mov  AX,[BP+4]
  ? #2,"Mov  $Xcur,AX
  ? #2,"Mov  AX,[BP+6]
  ? #2,"Mov  $Ycur,AX
  ? #2,"Pop  BP
  ? #2,"Ret  6
  ? #2,"Lineto Endp
  DoTwo
END IF



IF Use.Output THEN
  DoTwo
  ? #2,"Output Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  SI,[BP+4]
  ? #2,"Call Len
  ? #2,"Mov  CX,AX
  ? #2,"Mov  BX,1
  ? #2,"Mov  DX,[BP+4]
  ? #2,"Mov  AH,40h
  ? #2,"Int  21h
  ? #2,"Pop  BP
  ? #2,"Ret  02
  ? #2,"Output Endp
  DoTwo
END IF



IF Use.Index = %True THEN
  DoTwo
  ? #2,"_Index Proc Near
  ? #2,"Mov  SI,Offset $UserData
  ? #2,"Mov  BX,$DataCtr
  ? #2,"Mov  AX,[SI+BX]
  ? #2,"Add  $DataCtr,2
  ? #2,"Ret
  ? #2,"_Index Endp
  DoTwo
END IF


IF Use.SetRgb = %True THEN
  DoTwo
  ? #2,"SetRGB Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  AX,Word Ptr[BP+04]
  ? #2,"Mov  DH,AL
  ? #2,"Mov  AX,Word Ptr[BP+06]
  ? #2,"Mov  CH,AL
  ? #2,"Mov  AX,Word Ptr[BP+08]
  ? #2,"Mov  CL,AL
  ? #2,"Mov  AX,1010h
  ? #2,"Xor  BX,BX
  ? #2,"Int  10h
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret  06
  ? #2,"SetRGB  Endp
  DoTwo
END IF


IF Use.Stdin = %True THEN
  DoTwo
  ? #2,"Stdin$ Proc Near
  ? #2,"Push BP
  ? #2,"Mov  BP,SP
  ? #2,"Mov  $_1_,Byte Ptr 0
  ? #2,"Mov  AH,6
  ? #2,"Mov  DL,255
  ? #2,"Int  21h
  ? #2,"Jz   ExitStdIn
  ? #2,"Mov  $_1_,AL
  ? #2,"Mov  $_1_+1,Byte Ptr 0
  ? #2,"ExitStdIn:
  ? #2,"Mov  SP,BP
  ? #2,"Pop  BP
  ? #2,"Ret
  ? #2,"Stdin$ Endp
  DoTwo
END IF


IF Use.Gprint = %True THEN
  DoTwo
  ? #2,"GPrint Proc Near
  ? #2,"Call Len
  ? #2,"Push AX
  ? #2,"Mov  CX,AX
  ? #2,"Cmp  CX,0
  ? #2,"Jle  Gp_2
  ? #2,"Cld
  ? #2,"Gp_1:
  ? #2,"Mov  DX,$Xcur
  ? #2,"Dec  DL
  ? #2,"Mov  BX,$Ycur
  ? #2,"Mov  DH,BL
  ? #2,"Dec  DH
  ? #2,"Mov  AH,2
  ? #2,"Int  10h
  ? #2,"Lodsb
'************************
  ? #2,"Push AX"        '
  ? #2,"Push CX"        '
  ? #2,"Mov  CX,1"      '
  ? #2,"Xor  BX,BX"     ' <<<<   These lines "black" out each space first
  ? #2,"Mov  AH,9"      ' <<<<   otherwise the colors are screwed up thru
  ? #2,"Int  10h"       ' <<<<   the xor'ing of the BIOS putchar routine
  ? #2,"Pop  CX"        '
  ? #2,"Pop  AX"        '
'************************
  ? #2,"Mov  BX,FgColor
  ? #2,"Xor  BX,BgColor
  ? #2,"Add  BL,128
  ? #2,"Xor  BH,BH
  ? #2,"Push CX
  ? #2,"Mov  CX,1
  ? #2,"Mov  AH,9
  ? #2,"Int  10h
  ? #2,"Pop  CX
  ? #2,"Inc  $Xcur
  ? #2,"Loop Gp_1
  ? #2,"Gp_2:
  ? #2,"Pop  AX
  ? #2,"Ret
  ? #2,"Gprint Endp
  DoTwo
END IF


