' ***********************************************************
'   Utility to toggle the CAPS lock status on or off
'   For use with BASM -- The Free Basic to 80286 Asm Compiler
' ************************************************************

$Com

PRINT "CAPS  Caps Lock Toggle"

Cmd$ = UCASE$( COMMAND$ )

SELECT CASE Cmd$
  CASE ""    :  PRINT "Usage:  CAPS on | off | + | -"  :  END
  CASE "ON"  :  Stat = 1
  CASE "+"   :  Stat = 1
  CASE "OFF" :  Stat = 0
  CASE "-"   :  Stat = 0
END SELECT

DEF SEG = 0
  X = PEEK( &H417 )  'get keyboard toggles
  IF Stat THEN
    X = X OR &B01000000
    PRINT "CAPS LOCK is now ON"
  ELSE
    X = X AND &B10111111
    PRINT "CAPS LOCK is now OFF"
  END IF
  POKE &H417, X      'set keyboard toggles
DEF SEG
